c----------------------------------------
c Fortran Program for Packege BIDO
c (C) 2009 I. Cho All Rights Reserved.
c----------------------------------------
#include "PARAM_PREPROCESS.h"
      parameter(nmax=NMAX_INC,nmax_fft=NMAX_FFT_INC)
      implicit real*8 (a-h,o-z)                                         
      character*200 ifile,ofile,file,instfile(3)
      dimension x(nmax),x_cp(nmax),d(3,nmax)
      dimension freq_inst(nmax_fft),phase(nmax_fft),amp(nmax_fft)
      complex*16 cu(nmax_fft),res(nmax_fft)
      real dt4,fr1_4,fr2_4,fr3_4,fr4_4,x4(nmax)

      read(5,*)idnmaxcheck
      if(idnmaxcheck.eq.1)then
         read(5,*)kpoint0
         if(kpoint0.gt.nmax)then
            write(6,'(a,2i10)')'ERROR: The number of data exceeds'//
     +           ' the maximum (nmax) ', kpoint0, nmax 
            write(6,'(a)')
     +           'To continue, you should do either of the following:'
            write(6,'(a)')'i) Shorten the data length'
            write(6,'(a)')'ii) Skip the preprocessing'
            write(6,'(a)')'iii) Edit the parameber NMAX_INC '//
     +           'in src/PARAM_PREPROCESS.h and recompile the program'
         else
            write(6,*)kpoint0,' .... OK'
         endif
         stop
      endif

c     tpend=0.03d0
      ift=13
      idr=1
      read(5,'(a)')ifile
      read(5,'(a)')ofile
      read(5,*)idcomp0
      read(5,*)dt0,tbeg
      read(5,*)idtrd,iddtwin,tpend
      read(5,*)idbp,fr1,fr2,fr3,fr4
      read(5,*)idresamp
      read(5,*)idinst
      if(idinst.eq.1)then
         do idcomp=1,idcomp0
            read(5,'(a)')instfile(idcomp)
         enddo
      endif

      write(6,'(a)')'<Input parameters>'
      write(6,'(a)')'input file :'//ifile(1:index(ifile,' ')-1)
      write(6,'(a)')'output file:'//ofile(1:index(ofile,' ')-1)
      write(6,'(a,i5)')'idcomp0:',idcomp0
      write(6,'(a,2e15.6)')'dt,tbeg: ',dt0,tbeg
      write(6,'(a,2i5)')'iddtwin,idtrd: ',iddtwin,idtrd
      write(6,'(a,i5,4e15.6)')'idbp,fr1,fr2,fr3,fr4: ',
     +     idbp,fr1,fr2,fr3,fr4
      write(6,'(a,i5)')'idinst:',idinst
      write(6,*)

      if(idtrd.eq.1)then
         idtrd0=1
      else
         idtrd0=-1
      endif

      file=ifile
      open(15,file=file,status='old',err=999)
      file=ofile
      open(16,file=file,err=999)

      i=1
 10   continue

      if(     idcomp0.eq.1)then
         read(15,*,err=99,end=99)time,d(1,i)
      else if(idcomp0.eq.2)then
         read(15,*,err=99,end=99)time,dum,(d(idcomp,i),idcomp=1,2)
      else if(idcomp0.eq.3)then
         read(15,*,err=99,end=99)time,(d(idcomp,i),idcomp=1,3)
      endif

      i=i+1
      if(i.gt.nmax)then
         write(6,'(a,i8)')'ERROR: The number of data exceeds'//
     +        ' the maximum of nmax.', nmax 
         write(6,'(a)')
     +        'To continue, you should do either of the following:'
         write(6,'(a)')'i) Shorten the data length in '//
     +        ifile(1:index(ifile,' ')-1)
         write(6,'(a)')'ii) Skip the preprocessing'
         write(6,'(a)')'iii) Edit the parameber NMAX_INC '//
     +        'in src/PARAM_PREPROCESS.h and recompile the program'
         stop
      endif
      goto 10
 99   continue
      kpoint0=i-1

      write(6,'(a,i10)')'kpoint:',kpoint0

      do idcomp=1,idcomp0

c $B%j%5%s%W%j%s%0$G=q$-49$($i$l$k%Q%i%a!<%?$r$b$H$KLa$9!#(B
         dt=dt0
         kpoint=kpoint0


         write(6,*)
         write(6,'(a,i5,a,i5,a)')'PROCESSING THE DATA OF COMPONENT',
     +        idcomp,' (idcomp0=',idcomp0,')'
      
         do i=1,kpoint
            x(i)=d(idcomp,i)
         enddo

         if(idtrd0.eq.1)write(6,'(a)')'Trend eliminated'
         call dtrd(x,kpoint,x,idtrd0,slope,avex) !Remove Trend

c     DataWindow(TAPER)
         if(iddtwin.eq.1)then
            
            write(6,'(a,f8.3)')
     +           'Tapering applied at both ends: ',tpend
            nwidth=int(kpoint*tpend)+1         
            call dtwin(x,x,kpoint,nmax,nwidth) 
         endif
         
         if(idbp.eq.1)then
            write(6,'(a)')'bandpass filtering applied'
c            call saito(x,x,kpoint,dt,ift,idr,fr1,fr2,fr3,fr4)
            do i=1,kpoint
               x4(i)=x(i)*1.
            enddo 
            dt4=dt*1.
            fr1_4=fr1*1.
            fr2_4=fr2*1.
            fr3_4=fr3*1.
            fr4_4=fr4*1.
            call saito(x4,x4,kpoint,
     +                 dt4,ift,idr,fr1_4,fr2_4,fr3_4,fr4_4)
            do i=1,kpoint
               x(i)=x4(i)*1.
            enddo
         endif ! idbp

         if(idresamp.eq.1.and.idbp.eq.1)then
            write(6,'(a)')'Decimation applied'
            mabiki=1
 15         fn=1.d0/(2.d0*dt*mabiki)
            if(fn.lt.fr4.and.mabiki.eq.1)then
               write(6,*)'ERROR: fn > fr4'
               stop
            else if(fn.lt.fr4)then
               goto 20
            endif
            mabiki=mabiki+1
            goto 15
 20         continue
            mabiki=mabiki-1
            fn=1.d0/(2.d0*dt*mabiki)
c
            dt=dt*mabiki
            do i=1,kpoint
               x_cp(i)=x(i)
            enddo
            idum=1
            do i=1,kpoint,mabiki
               x(idum)=x_cp(i)
               idum=idum+1
            enddo
            kpoint=idum
         else
            mabiki=1
            fn=1.d0/(2.d0*dt)
         endif ! idresamp & idbp

c---------------------------------------------------------------------------
         if(idcomp.eq.1)then
c                                                $B=PNOJQ99Cm0U!'(Bprepro.sh$B$NCf$G(B 
            write(6,*)'Resample_Mabiki: ',mabiki     !<=logfile$B$r(Bgrep$B$7$F;HMQ(B
            write(6,*)'ResamplingTimeInterval: ',dt  !<=logfile$B$r(Bgrep$B$7$F;HMQ(B
            write(6,*)'NumberofDataResampled: ',kpoint !<=logfile$B$r(Bgrep$B$7$F;HMQ(B
            write(6,*)'NewNyquistFrequency: ',fn     !<=logfile$B$r(Bgrep$B$7$F;HMQ(B
         endif
c---------------------------------------------------------------------------

         if(idinst.eq.1)then
            write(6,'(a)')'Correction for the differences'//
     +           ' in instrumental response applied'
            file=instfile(idcomp)
            call rinst(idinstflag,
     +           freq_inst,phase,amp,kpoint_inst,file)

            ip=int(log10(float(kpoint))/log10(2.d0))
            lx=2**ip
            if(lx.lt.kpoint)then
               ip=ip+1
               lx=2**ip
            endif
            lx2=2*lx
            if(lx2.gt.nmax_fft)then
               write(6,*)
               write(6,'(a,2i15)')'ERROR:lx2 > nmax_fft ',lx2,nmax_fft
               write(6,'(a)')'Reset the parameter NMAX_FFT_INC'//
     +              ' in src/PARAM_PREPROCESS.h'//
     +              ' and recompile the program.'
               write(6,'(a)')'You should do the following to continue.'
               write(6,'(a)')'i)   Decrease the number'//
     +              ' of data points'//
     +              ' (by automatic decimation after bandpass'//
     +              ' filtering or shortening the data length).'
               write(6,*)'[The number of data points '//
     +              '(after bandpass filtering)'//
     +              ' should be smaller than ',
     +              2**int(log10(float(nmax_fft/2))/log10(2.d0)),']'
               write(6,'(a)')'ii)  Edit the parameter NMAX_FFT_INC'//
     +              ' in src/PARAM_PREPROCESS.h and recompile again.'
               write(6,*)'[NMAX_FFT_INC should be larger than ',lx2,']'
               stop
            endif
            nfold=lx+1
            TT=lx2*dt
            df=1.d0/TT

            PRfac=kpoint*dt/TT

            write(6,*)'Correction for the instrumental responses'
            write(6,*)'ip  ',ip
            write(6,*)'lx  ',lx
            write(6,*)'lx2 ',lx2
            write(6,*)'PRfac ',PRfac
            write(6,*)'idinstflag ',idinstflag

            if(idinstflag.eq.1)then
               call mkres(res,freq_inst,phase,amp,
     +              kpoint_inst,df,nfold)
            else
               do i=1,lx2 
                  res(i)=1.d0
               enddo
            endif
              
            do i=1,kpoint      
               cu(i)=x(i)
            enddo
            do i=kpoint+1,lx2    ! Zero padding
               cu(i)=0.d0
            enddo
            call fast(lx2,cu,nmax_fft,-1) ! FFT

c     correction for differenes in instrumental responses
            cu(1)=cu(1)/abs(res(1))/PRfac ! f=0
            do i=2,nfold-1
               cu(i)=cu(i)/res(i)/PRfac ! f=df,2df,...,f_nyq-df
            enddo
            cu(nfold)=cu(nfold)/abs(res(nfold))/PRfac ! f=f_nyq
            j=nfold
            do i=nfold+1,lx2
               j=j-1
               cu(i)=dconjg(cu(i)/res(j))/PRfac ! f=f_nyq-df,...,2df,df
            enddo

            call fast(lx2,cu,nmax_fft,1) ! inverse FFT
            do i=1,kpoint
               x(i)=cu(i)/dble(lx2)
            enddo
         endif                  ! idinst
         
         do i=1,kpoint
            d(idcomp,i)=x(i)
         enddo

      enddo ! idcomp

      if(     idcomp0.eq.1)then
         do i=1,kpoint
            write(16,*)tbeg+dt*(i-1),d(1,i)
         enddo
      else if(idcomp0.eq.2)then
         do i=1,kpoint
            write(16,*)tbeg+dt*(i-1),dum,(d(idcomp,i),idcomp=1,2)
         enddo
      else if(idcomp0.eq.3)then
         do i=1,kpoint
            write(16,*)tbeg+dt*(i-1),(d(idcomp,i),idcomp=1,3)
         enddo
      endif
      write(6,'(a)')'The program prepro ended successfully.'
      stop
 999  write(6,*)'ERROR:open file '//
     +     file(1:index(file,' ')-1)
      end

      subroutine   dtrd (x,n,y,ndeg,slope,avex)
      implicit real*8 (a-h,o-z)                                         
      dimension  x(1) , y(1)                                            
c*****this dtrd removes the mean and/or a linear trend                  
c***** x(i)- original series   , y(i)- calculated seies                 
c***** ndeg- code word  - if -1   no change
c                         if  0   only mean removed                      
c*****                  - if  1   both mean and linear trend removed     
c$B!V%i%s%@%`%G!<%?$N!"!"!W$N(Bp288$B;2>H(B
      an = n                                                            
      s1 = 0.0d0                                                          
      s2 = 0.0d0                                                          
      slope=12345.d0
      if ( ndeg ) 9,11,20                                              
 9    return
   11 do 12 i=1,n                                                       
   12 s1 = s1 + x(i)                                                  
      avex = s1 / an                                                    
      do 15  i=1,n                                                      
   15 y(i) = x(i) -avex                               
      return                                                            
   20 do 22 i=1,n                                                       
      s1 = s1 + x(i)                                            
   22 s2 = s2 + s1                                                      
      avei = 0.5d0*(an+1.0d0)                                             
      avex = s1 / an                                                    
      slope = -12.0d0*(s2-avei*s1)/(an*(an**2-1.0d0))     
      do 28 i=1,n                                                       
      ai = i                                                            
   28 y(i) = x(i)-avex-slope*(ai-avei )            
c      write(6,*)'DEBUG:Subroutine(drtr):',slope,avex
      return                                                            
      end                                                               

      subroutine dtwin(x,y,n,nmax,nwidth)
c Hanning (cos) window
      implicit real*8 (a-h,o-z)                                               
      dimension x(nmax),y(nmax)
      pi2=acos(-1.d0)/2.d0
      if(nwidth.eq.0)then
         return
      endif
      darg=pi2/(nwidth-1)
      iarg=0
      do 10 i=1,nwidth
         fac=sin(darg*iarg)
         y(i)=fac*x(i)
         iarg=iarg+1
 10   continue
      do 20 i=nwidth,n-nwidth
         y(i)=x(i)
 20   continue
      iarg=0
      do 30 i=n-nwidth+1,n
         fac=cos(darg*iarg)
         y(i)=fac*x(i)
         iarg=iarg+1
 30   continue
      return
      end

      subroutine fast(n,x,nd,ind)    
c  FFT subroutine taken after Ohzaki
c  $B%U!<%j%(JQ49$NDj5A$G&X$NId9f$N$_$+$($?!#(B(May10, 2003)
      implicit real*8 (a-h,o-z)                                         
      complex*16  x (nd),temp,theta
c--------------------------------------------------
      ind0=-1*ind
c--------------------------------------------------
      j=1
      do 140 i=1,n
         if(i.ge.j)goto 110
         temp=x(j)
         x(j)=x(i)
         x(i)=temp
 110  m=n/2
 120  if(j.le.m)goto 130
      j=j-m
      m=m/2
      if(m.ge.2)goto 120
 130  j=j+m
 140  continue
      kmax=1
 150  if(kmax.ge.n)return
      istep=kmax*2
      do 170 k=1,kmax
         theta=dcmplx(0.d0,3.141593d0*dble(ind0*(k-1))/dble(kmax))
         do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*exp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
 160     continue
 170  continue
      kmax=istep
      goto 150
      end

      subroutine rinst(idinstflag,freq,phase,amp,kpoint_inst,file)
      implicit real*8 (a-h,o-z)                                         
      parameter(nmax_fft=NMAX_FFT_INC)
      dimension  freq(nmax_fft),phase(nmax_fft),amp(nmax_fft)
      character*200 file
      idinstflag=1

c                                      $B=PNOJQ99Cm0U!'(Bprepro.sh$B$NCf$G(B 
c                                      logfile$B$r(Bgrep$B$7$F;HMQ(B
      write(6,'(a)')'Open the file describing'//
     +     ' the instrumental response: '//file(1:index(file,' ')-1)
c

      open(17,file=file,status='old',err=500)
      i=1
 10   continue
      read(17,*,err=99,end=99)freq(i),amp(i),phase(i)
      i=i+1
      if(i.gt.nmax_fft)then
         write(6,'(a,2i8)')'ERROR:'//
     +        ' No of data for the array cu_inst exceeded'//
     +        ' the maximum ',nmax_fft
         write(6,'(a)')'You should do the following to continue.'
         write(6,'(a)')'i)   Shorten the data length in'//
     +        file(1:index(file,' ')-1)
         write(6,'(a)')'ii)  Skip preprocessing'
         write(6,'(a)')'iii) Edit the parameter NMAX_FFT_INC'//
     +        ' in src/PARAM_PREPROCESS.h and recompile again.'
         stop
      endif
      goto 10
 99   continue
      kpoint_inst=i-1
      close(17)
      write(6,*)'Read data from Frequency ',freq(1),' to 
     +     ',freq(kpoint_inst),'[Hz]'
      return
c
 500  continue
      write(6,'(a)')'File not found: '//file(1:index(file,' ')-1)
      idinstflag=0
      return
      end

      subroutine mkres(res,freq_inst,phase,amp,
     +     kpoint_inst,df,nfold)
      implicit real*8 (a-h,o-z)                                         
      parameter(nmax_fft=NMAX_FFT_INC)
      dimension freq_inst(nmax_fft),phase(nmax_fft),amp(nmax_fft)
      complex*16 res(nmax_fft),ai,y1,y2,a
c linear interpolatin
      ai=(0.,1.d0)
      pi=acos(-1.d0)
      d2r=pi/180.d0
      eps=1.d-8
      idum=1
      do i=1,nfold
         f=df*(i-1)
 500     continue
         if(f.lt.freq_inst(1))then
            k=1
         else if(f.gt.freq_inst(kpoint_inst))then
            k=kpoint_inst-1
         elseif(f.ge.freq_inst(idum)-eps.
     +           and.f.le.freq_inst(idum+1)+eps)then
            k=idum
         else 
            idum=idum+1
            goto 500
         endif
         y2=amp(k+1)*exp(-ai*d2r*phase(k+1))
         y1=amp(k  )*exp(-ai*d2r*phase(k  ))
         x2=freq_inst(k+1)
         x1=freq_inst(k)
         a=(y2-y1)/(x2-x1)
         res(i)=a*(f-x1)+y1
      enddo
      return
      end

      real*8 function  atan360(x,y)
      implicit real*8 (a-h,o-z)                                         
      pi=acos(-1.d0)
      if(y.eq.0.d0.and.x.ge.0.d0)then
         atan360=0.d0
         return
      else if(y.eq.0.d0.and.x.lt.0.d0)then
         atan360=180.d0
         return
      endif
      if(x.eq.0.d0.and.y.gt.0.d0)then
         atan360=90.d0
         return
      else if(x.eq.0.d0.and.y.lt.0.d0)then
         atan360=270.d0
         return
      endif
      atan360=180.d0/pi*atan(y/x)
      if(x.lt.0)then
         atan360=atan360+180.d0
      else if(x.gt.0.and.y.lt.0)then
         atan360=atan360+360.d0
      endif
 10   continue
      if(atan360.ge.0.d0.and.atan360.lt.360.d0)then
         return
      else if(atan360.lt.0.d0)then
         atan360=atan360+360.d0
      else if(atan360.ge.360.d0)then
         atan360=atan360-360.d0
      endif
      goto 10
      end

      real*8 function range180(x)
      implicit real*8 (a-h,o-z)
      range180=x      
 10   continue
      if(range180.lt.-180.d0)then
         range180=range180+360.d0
      else if(range180.gt.180.d0)then
         range180=range180-360.d0
      else
         return
      endif
      goto 10
      end
